// ==UserScript==
// @name           Wassr Favorite Commands
// @namespace      http://www.smellman.homelinux.org/mozilla/greasemonkey/
// @description    add Wassr favorite and other commands to Minibuffer
// @include        http://wassr.jp/my*
// @include        http://wassr.jp/user/*
// @author         Taro Matsuzawa
// ==/UserScript==
// (1)

// (2)
if(!window.Minibuffer) return;
(function() {
    
    //(3)
    // setPassword method
    function setPassword(bool) {
	if (!GM_getValue('wassr.id') || !bool) {
	    GM_setValue('wassr.id',
			window.prompt("Please input wassr id"));
	}
	if (!GM_getValue('wassr.password')|| !bool) {
	    GM_setValue('wassr.password',
			window.prompt("Plaese input wassr password"));
	}
    }
    // resetPassword method (from GM_registerMenuCommand)
    function resetPassword() {
	setPassword(false);
    }
    
    // set id and password only after install
    setPassword(true);
    
    // reset id and password command
    GM_registerMenuCommand("Reset wassr id and Password", resetPassword);
    
    //(4)
    // remove default wassr's shortcut
    unsafeWindow.shortcut.remove('p');

    var Re = {
	wassr:/https?:\/\/wassr\.jp\/user\/(\w*)\/statuses\/(\w*)/
    };
    
    // (5)
    // Wassr::Favorite::Add command
    // example: pinned-or-current-link | Wassr::Favorite::Add
    window.Minibuffer.addCommand({
	name: 'Wassr::Favolite::Add',
	command: function(stdin){
	    stdin.forEach(function(obj){
		if (obj.href.match(Re.wassr)) {
		    var id = RegExp.$2;
		    var update_url = 'http://' + GM_getValue('wassr.id')
			+ ":" + GM_getValue('wassr.password')
			+ "@api.wassr.jp/favorites/create/"
			+ id + ".json";
		    var details = {
			method: 'POST',
			url: update_url,
			onload: function(res) {
			    window.Minibuffer.status('Favorite Add to ' + id, 'Add... done', 100);
			},
			onerror: function(res) {
			    window.Minibuffer.status('Favorite Add to ' + id, 'Add... failed', 100);
			},
		    };
		    GM_xmlhttpRequest(details);
		}
	    });
	},
    });

    // (6)
    // Wassr::Favorite::Delete command
    // example: pinned-or-current-link | Wassr::Favorite::Delete
    window.Minibuffer.addCommand({
	name: 'Wassr::Favolite::Delete',
	command: function(stdin){
	    stdin.forEach(function(obj){
		if (obj.href.match(Re.wassr)) {
		    var id = RegExp.$2;
		    var update_url = 'http://' + GM_getValue('wassr.id')
			+ ":" + GM_getValue('wassr.password')
			+ "@api.wassr.jp/favorites/destroy/"
			+ id + ".json";
		    var details = {
			method: 'POST',
			url: update_url,
			onload: function(res) {
			    window.Minibuffer.status('Favorite Delete to ' + id, 'Delete... done', 100);
			},
			onerror: function(res) {
			    window.Minibuffer.status('Favorite Delete to ' + id, 'Delete... failed', 100);
			},
		    };
		    GM_xmlhttpRequest(details);
		}
	    });
	},
    });
    
    // (7)
    // Wassr::List::User
    // example: pinned-or-current-link | Wassr::List::User | open
    window.Minibuffer.addCommand({
	name: 'Wassr::List::User',
	command: function(stdin) {
	    var _stdin = [];
	    stdin.forEach(function(obj) {
		if (obj.href.match(Re.wassr)) {
		    var user = RegExp.$1;
		    var url = 'http://wassr.jp/user/' + user;
		    _stdin.push(url);
		}
	    });
	    return _stdin;
	}
    });

    // (8)
    // add shortcut 'w f a' to Wassr::Favorite::Add
    window.Minibuffer.addShortcutkey({
	key: 'w f a',
	description: 'Wassr::Favolite::Add',
	command: function(){
	    var stdin = [];
	    try {
		stdin = window.Minibuffer.execute('pinned-or-current-link');
	    } catch (e) {}
	    window.Minibuffer.execute('Wassr::Favolite::Add', stdin);
	    window.Minibuffer.execute('clear-pin');
	},
    });

    // add shortcut 'w f d' to Wassr::Favorite::Delete
    window.Minibuffer.addShortcutkey({
	key: 'w f d',
	description: 'Wassr::Favolite::Delete',
	command: function(){
	    var stdin = [];
	    try {
		stdin = window.Minibuffer.execute('pinned-or-current-link');
	    } catch (e) {}
	    window.Minibuffer.execute('Wassr::Favolite::Delete', stdin);
	    window.Minibuffer.execute('clear-pin');
	},
    });

    // add shortcut 'w l u' to Wassr::List::User
    window.Minibuffer.addShortcutkey({
	key: 'w l u',
	description: 'Wassr::List::User',
	command: function(){
	    var stdin = [];
	    try {
		stdin = window.Minibuffer.execute('pinned-or-current-link');
		stdin = window.Minibuffer.execute('Wassr::List::User', stdin);
	    } catch (e) {};
	    window.Minibuffer.execute('open', stdin);
	    window.Minibuffer.execute('clear-pin');
	}
    });

})()
